/***************************************************************************/
/**                                                                       **/
/**              DDUtils By John Richardson and Dan Vanderboom            **/
/**            Copyright 1990 John Richardson and Dan Vanderboom          **/
/**                                                                       **/
/**                         TopSoft Support Systems                       **/
/**                         2135 Possum Ct.                               **/
/**                         Brookfield, Wi 53045                          **/
/**                         /414/796-8408 Data 12/24                      **/
/**                                                                       **/
/**                                                                       **/
/***************************************************************************/
/**                                                                       **/
/**                                                                       **/
/** v1.00: Initial Release of TurboC Version                              **/
/***************************************************************************/

#include <dos.h>

int ddactive(void);
void givetime(int amount);
void taskoff(void);
void taskon(void);
int invisible(void);
void dd_switch(void);
void resume_invisible(void);
void kill_other_job(void);
void suspend_invisible(void);
void clear_keyboard_buffer(void);
int send_char(char ch);
int program_status(void);
int task_number(void);
int other_status(void);
void time_sharing(int num);
int current_timeshare(void);

/***************************************************************************/

int ddactive(void)
{
   union REGS regs;

   regs.h.ax = 0xE400;
   int86(0x21,&regs,&regs);
   if (regs.h.al != 0x00) return(1);
   return(0);
}

/***************************************************************************/

void givetime(int amount)
{
   union REGS regs;

   regs.h.ah = 0xEE;
   regs.h.al = amount;
   int86(0x21,&regs,&regs);
}

/***************************************************************************/

void taskoff(void)
{
   union REGS regs;

   regs.h.ah = 0xEA;
   int86(0x21,&regs,&regs);
}

/***************************************************************************/

void taskon(void)
{
   union REGS regs;

   regs.h.ah = 0xEB;
   int86(0x21,&regs,&regs);
}

/***************************************************************************/

int invisible(void)
{
   union REGS regs;

   regs.h.ax = 0xE400;
   int86(0x21,&regs,&regs);
   if (regs.h.al == 0x02) return(1);
   return(0);
}

/***************************************************************************/

void dd_switch(void)
{
   union REGS regs;

   regs.h.ah = 0xE0;
   regs.h.al = 1;
   int86(0x21,&regs,&regs);
}

/***************************************************************************/

void resume_invisible(void)
{
    union REGS regs;

    regs.h.ah = 0xE0;
    regs.h.al = 0x73;
    int86(0x21,&regs,&regs);
}

/***************************************************************************/

void kill_other_job(void)
{
    union REGS regs;

    regs.h.ah = 0xE0;
    regs.h.al = 0x74;
    int86(0x21,&regs,&regs);
}

/***************************************************************************/

void suspend_invisible(void)
{
    union REGS regs;

    regs.h.ah = 0xE0;
    regs.h.al = 0x75;
    int86(0x21,&regs,&regs);
}

/***************************************************************************/

void clear_keyboard_buffer(void)
{
   union REGS regs;

   regs.h.ah = 0xE1;
   int86(0x21,&regs,&regs);
}

/***************************************************************************/

int send_char(char ch)
{
   union REGS regs;

   regs.h.ah = 0xE2;
   regs.h.dl = (int) ch;
   int86(0x21,&regs,&regs);
   if (regs.h.al == 0) return(1);
   return(0);
}

/***************************************************************************/

int program_status(void)
{
   union REGS regs;

   regs.h.ah = 0xE4;
   int86(0x21,&regs,&regs);
   return(regs.h.al);
   /** al = 1 program is visible
       al = 1 program is invisibile
       al = any other value means DoubleDOS not running
       ah = task number (0=top, 1=bottom job) **/
}

/***************************************************************************/

int task_number(void)
{
   union REGS regs;

   regs.h.ah = 0xE4;
   int86(0x21,&regs,&regs);
   return(regs.h.ah);  /** 0 = top, 1 = bottom **/
}

/***************************************************************************/

int other_status(void)
{
   union REGS regs;

   regs.h.ah = 0xE5;
   int86(0x21,&regs,&regs);
   return(regs.h.al);
   /** al = 0 no program running
       al = 1 program is running
       al = 2 program is suspended **/
}

/***************************************************************************/

void time_sharing(int num)
{
   union REGS regs;

   /** Num Variable

       0 = visible program gets 70% invisible gets 30% (default)
       1 = visible program gets 50% invisible gets 50% of time
       2 = visible program gets 30% invisible gets 70% of time
       3 = top program gets 70% bottom program gets 30% of time
       4 = top program gets 30% bottom program gets 70% of time
       5 = returns current priotity setting in al **/

   regs.h.ah = 0xE9;
   regs.h.al = num;
   int86(0x21,&regs,&regs);
}

/***************************************************************************/

int current_timeshare(void)
{
   union REGS regs;

   regs.h.ah = 0xE9;
   regs.h.al = 5;
   int86(0x21,&regs,&regs);
   return(regs.h.al);
}

/***************************************************************************/

